#!/bin/bash
echo "TSDCLI version 2.3"
echo
INP=tscli.$$.inp

usage() {
echo " Error! Please supply the required parameters!"
echo "."
echo "  Syntax:"
echo "    tsdcli xxx.xxx.xxx.xxx output password"
echo "."
echo "    xxx.xxx.xxx.xxx is the IP address of the RAID controller."
echo "    'output' is the output filename. "
echo "       It will be added .txt filename extention automatically."
echo "    'password' is optional. Leave it blank if there is no password."
echo "       It is the RAID controller password. If the password entered "
echo "       is wrong, it will be shown in the output file."
echo "."
echo "    !! WARNING !! "
echo "   The controller password you entered will be seen in the output file! "
echo "   Modify the output file before forwarding it to anyone, to keep your "
echo "   password hidden."
echo "."
echo "   If the outout file shows "Lock device failed !" in many lines, "
echo "  please remove RAID controller password first, then run TSDCLI "
echo "  again without the password. "
echo "."
}

make_inp() {
echo " show cli ">> ${INP}
echo " SCAN array ">> ${INP}
echo " show controller ">> ${INP}
echo " show controller date ">> ${INP}
echo " show fru ">> ${INP}
echo " show rs232 ">> ${INP}
echo " show task ">> ${INP}
echo " show enclosure ">> ${INP}
echo " show access-mode ">> ${INP}
echo " show schedule ">> ${INP}
echo " show event ">> ${INP}
echo " show controller trigger ">> ${INP}
echo " show controller parm ">> ${INP}
echo " show controller redundancy ">> ${INP}
echo " show shutdown-status ">> ${INP}
echo " show host ">> ${INP}
echo " show disk parm ">> ${INP}
echo " show channel ">> ${INP}
echo " show net ">> ${INP}
echo " show cache ">> ${INP}
echo " show wwn ">> ${INP}
echo " show ld ">> ${INP}
echo " show lv ">> ${INP}
echo " show part ">> ${INP}
echo " show disk ">> ${INP}
echo " show disk spare ">> ${INP}
echo " show array ">> ${INP}
echo " show map ">> ${INP}
echo " show iqn ">> ${INP}
echo " show stripe ">> ${INP}
echo " show disk channel=0 ">> ${INP}
echo " show disk channel=1 ">> ${INP}
echo " show disk channel=2 ">> ${INP}
echo " show disk channel=3 ">> ${INP}
echo " show disk channel=4 ">> ${INP}
echo " show disk channel=5 ">> ${INP}
echo " show disk channel=6 ">> ${INP}
echo " show disk channel=7 ">> ${INP}
echo " show disk channel=8 ">> ${INP}
echo " show disk channel=9 ">> ${INP}
echo " show disk channel=10 ">> ${INP}
echo " show disk channel=11 ">> ${INP}
echo " show disk channel=12 ">> ${INP}
echo " show disk channel=13 ">> ${INP}
echo " show disk channel=14 ">> ${INP}
echo " show disk channel=15 ">> ${INP}
echo " show disk channel=16 ">> ${INP}
echo " show disk channel=17 ">> ${INP}
echo " show disk channel=18 ">> ${INP}
echo " show disk channel=19 ">> ${INP}
echo " show disk channel=20 ">> ${INP}
echo " show disk channel=21 ">> ${INP}
echo " show disk channel=22 ">> ${INP}
echo " show disk channel=23 ">> ${INP}
echo " show disk channel=24 ">> ${INP}
echo " show disk channel=25 ">> ${INP}
echo " show disk channel=26 ">> ${INP}
echo " show disk channel=27 ">> ${INP}
echo " show disk channel=28 ">> ${INP}
echo " show disk channel=29 ">> ${INP}
echo " show disk channel=30 ">> ${INP}
echo " show disk channel=31 ">> ${INP}
echo " show snapshot ">> ${INP}
echo " disconnect ">> ${INP}
echo " exit ">> ${INP}
echo " Connecting to $1 and collecting details..."
java -jar raidcmd21.jar < ${INP} > $2.txt
echo " Done! The RAID subsystem details have been stored in the file: $2.txt"
}

noping () {
echo "."
echo " This IP address does not respond to a ping; please check the IP address and try again!"
echo "."
}


if [ $# -lt 2 ]; then
usage
exit 1
fi

echo Controller IP Address is $1
echo " Pinging $1"
ping -c 1 $1 >> /dev/null
if [ $? -ne 0 ]; then
	noping
	exit 1
else
	echo " IP address has responded to Ping"
	if [ $# -ge 3 ]; then
		echo " Controller password entered"
		echo " connect $1 -p $3 "> ${INP}
	else
		echo " No controller password entered"
		echo " connect $1 "> ${INP}
	fi
	make_inp $@
	/bin/rm ${INP}
fi
